## GtkGrid

GtkGrid — Pack widgets in a rows and columns

## Functions

GtkWidget * | gtk_grid_new ()
void | gtk_grid_attach ()
void | gtk_grid_attach_next_to ()
GtkWidget * | gtk_grid_get_child_at ()
void | gtk_grid_insert_row ()
void | gtk_grid_insert_column ()
void | gtk_grid_remove_row ()
void | gtk_grid_remove_column ()
void | gtk_grid_insert_next_to ()
void | gtk_grid_set_row_homogeneous ()
gboolean | gtk_grid_get_row_homogeneous ()
void | gtk_grid_set_row_spacing ()
guint | gtk_grid_get_row_spacing ()
void | gtk_grid_set_column_homogeneous ()
gboolean | gtk_grid_get_column_homogeneous ()
void | gtk_grid_set_column_spacing ()
guint | gtk_grid_get_column_spacing ()
gint | gtk_grid_get_baseline_row ()
void | gtk_grid_set_baseline_row ()
GtkBaselinePosition | gtk_grid_get_row_baseline_position ()
void | gtk_grid_set_row_baseline_position ()

## Properties

gint | baseline-row | Read / Write
gboolean | column-homogeneous | Read / Write
gint | column-spacing | Read / Write
gboolean | row-homogeneous | Read / Write
gint | row-spacing | Read / Write

## Child Properties

gint | height | Read / Write
gint | left-attach | Read / Write
gint | top-attach | Read / Write
gint | width | Read / Write

## Types and Values

struct | GtkGrid
struct | GtkGridClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkGrid

## Implemented Interfaces

GtkGrid implements AtkImplementorIface, GtkBuildable and GtkOrientable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkGrid is a container which arranges its child widgets in rows and columns. It is a very similar to GtkTable and GtkBox, but it consistently uses GtkWidget’s “margin” and “expand” properties instead of custom child properties, and it fully supports height-for-width geometry management.

Children are added using `gtk_grid_attach()`. They can span multiple rows or columns. It is also possible to add a child next to an existing child, using `gtk_grid_attach_next_to()`. The behaviour of GtkGrid when several children occupy the same grid cell is undefined.

GtkGrid can be used like a GtkBox by just using `gtk_container_add()`, which will place children next to each other in the direction determined by the “orientation” property.

## Functions

### gtk_grid_new ()

    GtkWidget *
    gtk_grid_new (void);

Creates a new grid widget.

#### Returns

the new GtkGrid

### gtk_grid_attach ()

    void
    gtk_grid_attach (GtkGrid *grid,
                     GtkWidget *child,
                     gint left,
                     gint top,
                     gint width,
                     gint height);

Adds a widget to the grid.

The position of `child` is determined by `left` and `top` . The number of “cells” that `child` will occupy is determined by `width` and `height` .

#### Parameters

grid | a GtkGrid |
child | the widget to add |
left | the column number to attach the left side of `child` to |
top | the row number to attach the top side of `child` to |
width | the number of columns that `child` will span |
height | the number of rows that `child` will span |

### gtk_grid_attach_next_to ()

    void
    gtk_grid_attach_next_to (GtkGrid *grid,
                             GtkWidget *child,
                             GtkWidget *sibling,
                             GtkPositionType side,
                             gint width,
                             gint height);

Adds a widget to the grid.

The widget is placed next to `sibling` , on the side determined by `side` . When `sibling` is `NULL`, the widget is placed in row (for left or right placement) or column 0 (for top or bottom placement), at the end indicated by `side` .

Attaching widgets labeled [1], [2], [3] with `sibling` == `NULL` and `side` == `GTK_POS_LEFT` yields a layout of 3[1].

#### Parameters

grid | a GtkGrid |
child | the widget to add |
sibling | the child of `grid` that `child` will be placed next to, or `NULL` to place `child` at the beginning or end. | [allow-none]
side | the side of `sibling` that `child` is positioned next to |
width | the number of columns that `child` will span |
height | the number of rows that `child` will span |

### gtk_grid_get_child_at ()

    GtkWidget *
    gtk_grid_get_child_at (GtkGrid *grid,
                           gint left,
                           gint top);

Gets the child of `grid` whose area covers the grid cell whose upper left corner is at `left` , `top` .

#### Parameters

grid | a GtkGrid |
left | the left edge of the cell |
top | the top edge of the cell |

#### Returns

the child at the given position, or `NULL`.

[transfer none]

Since 3.2

### gtk_grid_insert_row ()

    void
    gtk_grid_insert_row (GtkGrid *grid,
                         gint position);

Inserts a row at the specified position.

Children which are attached at or below this position are moved one row down. Children which span across this position are grown to span the new row.

#### Parameters

grid | a GtkGrid |
position | the position to insert the row at |

Since 3.2

### gtk_grid_insert_column ()

    void
    gtk_grid_insert_column (GtkGrid *grid,
                            gint position);

Inserts a column at the specified position.

Children which are attached at or to the right of this position are moved one column to the right. Children which span across this position are grown to span the new column.

#### Parameters

grid | a GtkGrid |
position | the position to insert the column at |

Since 3.2

### gtk_grid_remove_row ()

    void
    gtk_grid_remove_row (GtkGrid *grid,
                         gint position);

Removes a row from the grid.

Children that are placed in this row are removed, spanning children that overlap this row have their height reduced by one, and children below the row are moved up.

#### Parameters

grid | a GtkGrid |
position | the position of the row to remove |

Since 3.10

### gtk_grid_remove_column ()

    void
    gtk_grid_remove_column (GtkGrid *grid,
                            gint position);

Removes a column from the grid.

Children that are placed in this column are removed, spanning children that overlap this column have their width reduced by one, and children after the column are moved to the left.

#### Parameters

grid | a GtkGrid |
position | the position of the column to remove |

Since 3.10

### gtk_grid_insert_next_to ()

    void
    gtk_grid_insert_next_to (GtkGrid *grid,
                             GtkWidget *sibling,
                             GtkPositionType side);

Inserts a row or column at the specified position.

The new row or column is placed next to `sibling` , on the side determined by `side` . If `side` is `GTK_POS_TOP` or `GTK_POS_BOTTOM`, a row is inserted. If `side` is `GTK_POS_LEFT` of `GTK_POS_RIGHT`, a column is inserted.

#### Parameters

grid | a GtkGrid |
sibling | the child of `grid` that the new row or column will be placed next to |
side | the side of `sibling` that `child` is positioned next to |

Since 3.2

### gtk_grid_set_row_homogeneous ()

    void
    gtk_grid_set_row_homogeneous (GtkGrid *grid,
                                  gboolean homogeneous);

Sets whether all rows of `grid` will have the same height.

#### Parameters

grid | a GtkGrid |
homogeneous | `TRUE` to make rows homogeneous |

### gtk_grid_get_row_homogeneous ()

    gboolean
    gtk_grid_get_row_homogeneous (GtkGrid *grid);

Returns whether all rows of `grid` have the same height.

#### Parameters

grid | a GtkGrid |

#### Returns

whether all rows of `grid` have the same height.

### gtk_grid_set_row_spacing ()

    void
    gtk_grid_set_row_spacing (GtkGrid *grid,
                              guint spacing);

Sets the amount of space between rows of `grid` .

#### Parameters

grid | a GtkGrid |
spacing | the amount of space to insert between rows |

### gtk_grid_get_row_spacing ()

    guint
    gtk_grid_get_row_spacing (GtkGrid *grid);

Returns the amount of space between the rows of `grid` .

#### Parameters

grid | a GtkGrid |

#### Returns

the row spacing of `grid`

### gtk_grid_set_column_homogeneous ()

    void
    gtk_grid_set_column_homogeneous (GtkGrid *grid,
                                     gboolean homogeneous);

Sets whether all columns of `grid` will have the same width.

#### Parameters

grid | a GtkGrid |
homogeneous | `TRUE` to make columns homogeneous |

### gtk_grid_get_column_homogeneous ()

    gboolean
    gtk_grid_get_column_homogeneous (GtkGrid *grid);

Returns whether all columns of `grid` have the same width.

#### Parameters

grid | a GtkGrid |

#### Returns

whether all columns of `grid` have the same width.

### gtk_grid_set_column_spacing ()

    void
    gtk_grid_set_column_spacing (GtkGrid *grid,
                                 guint spacing);

Sets the amount of space between columns of `grid` .

#### Parameters

grid | a GtkGrid |
spacing | the amount of space to insert between columns |

### gtk_grid_get_column_spacing ()

    guint
    gtk_grid_get_column_spacing (GtkGrid *grid);

Returns the amount of space between the columns of `grid` .

#### Parameters

grid | a GtkGrid |

#### Returns

the column spacing of `grid`

### gtk_grid_get_baseline_row ()

    gint
    gtk_grid_get_baseline_row (GtkGrid *grid);

Returns which row defines the global baseline of `grid` .

#### Parameters

grid | a GtkGrid |

#### Returns

the row index defining the global baseline

Since 3.10

### gtk_grid_set_baseline_row ()

    void
    gtk_grid_set_baseline_row (GtkGrid *grid,
                               gint row);

Sets which row defines the global baseline for the entire grid. Each row in the grid can have its own local baseline, but only one of those is global, meaning it will be the baseline in the parent of the `grid` .

#### Parameters

grid | a GtkGrid |
row | the row index |

#### Returns

the row index defining the global baseline

Since 3.10

### gtk_grid_get_row_baseline_position ()

    GtkBaselinePosition
    gtk_grid_get_row_baseline_position (GtkGrid *grid,
                                        gint row);

Returns the baseline position of `row` as set by `gtk_grid_set_row_baseline_position()` or the default value `GTK_BASELINE_POSITION_CENTER`.

#### Parameters

grid | a GtkGrid |
row | a row index |

#### Returns

the baseline position of `row`

Since 3.10

### gtk_grid_set_row_baseline_position ()

    void
    gtk_grid_set_row_baseline_position (GtkGrid *grid,
                                        gint row,
                                        GtkBaselinePosition pos);

Sets how the baseline should be positioned on `row` of the grid, in case that row is assigned more space than is requested.

#### Parameters

grid | a GtkGrid |
row | a row index |
pos | a GtkBaselinePosition |

Since 3.10

## Types and Values

### struct GtkGrid

    struct GtkGrid;

### struct GtkGridClass

    struct GtkGridClass {
      GtkContainerClass parent_class;
    };

#### Members

GtkContainerClass `parent_class`; | The parent class. |

## Property Details

### The `“baseline-row”` property

      “baseline-row”             gint

The row to align the to the baseline when valign is GTK_ALIGN_BASELINE.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“column-homogeneous”` property

      “column-homogeneous”       gboolean

If TRUE, the columns are all the same width.

Flags: Read / Write

Default value: FALSE

### The `“column-spacing”` property

      “column-spacing”           gint

The amount of space between two consecutive columns.

Flags: Read / Write

Allowed values: [0,32767]

Default value: 0

### The `“row-homogeneous”` property

      “row-homogeneous”          gboolean

If TRUE, the rows are all the same height.

Flags: Read / Write

Default value: FALSE

### The `“row-spacing”` property

      “row-spacing”              gint

The amount of space between two consecutive rows.

Flags: Read / Write

Allowed values: [0,32767]

Default value: 0

## Child Property Details

### The `“height”` child property

      “height”                   gint

The number of rows that a child spans.

Flags: Read / Write

Allowed values: >= 1

Default value: 1

### The `“left-attach”` child property

      “left-attach”              gint

The column number to attach the left side of the child to.

Flags: Read / Write

Default value: 0

### The `“top-attach”` child property

      “top-attach”               gint

The row number to attach the top side of a child widget to.

Flags: Read / Write

Default value: 0

### The `“width”` child property

      “width”                    gint

The number of columns that a child spans.

Flags: Read / Write

Allowed values: >= 1

Default value: 1

## See Also

GtkTable, GtkHBox, GtkVBox